/***************************************************************************
sat_masterreparaciones.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
  var ctx:Object;
  function interna( context ) { this.ctx = context; }
  function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
  var cbxTipoRep:QComboBox;
  var cbxEstadoRep:Object;
  var chxInvertir:Object;
  var pbnGAlbaran:Object;
  var tdbRecords:FLTableDB;
  var tbnImprimir:Object;
  var tbnImprimirTicket:Object;
  var pbnArchivarReparacion:Object;
  var filtro:String;
  var fechaDesde:Object;
  var fechaHasta:Object;
  function oficial( context ) { interna( context ); }
  function imprimir(codreparacion:String) {
	return this.ctx.oficial_imprimir(codreparacion);
  }
  function imprimirTicket(codreparacion:String) {
	return this.ctx.oficial_imprimirTicket(codreparacion);
  }
  function filtroSAT() {
	return this.ctx.oficial_filtroSAT();
  }
  function actualizarFiltro() {
      return this.ctx.oficial_actualizarFiltro();
  }
  function procesarEstado() {
	return this.ctx.oficial_procesarEstado();
  }
  function pbnArchivarReparacion_clicked() {
	return this.ctx.oficial_pbnArchivarReparacion_clicked();
  }
  function pbnGenerarAlbaran_clicked() {
	return this.ctx.oficial_pbnGenerarAlbaran_clicked();
  }
  function generarAlbaran(where:String, cursor:FLSqlCursor):Number {
	return this.ctx.oficial_generarAlbaran(where, cursor);
  }
  function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
	return this.ctx.oficial_commonCalculateField(fN, cursor);
  }
  function copiaLineas(idReparacion:Number, idAlbaran:Number):Boolean {
	return this.ctx.oficial_copiaLineas(idReparacion, idAlbaran);
  }
  function copiaLineaReparacion(curLineaReparacion:FLSqlCursor, idAlbaran:Number):Number {
	return this.ctx.oficial_copiaLineaReparacion(curLineaReparacion, idAlbaran);
  }
  function actualizarDatosReparacion(where:String, idAlbaran:String):Boolean {
	return this.ctx.oficial_actualizarDatosReparacion(where, idAlbaran);
  }
  function datosLineaReparacion(curLineaReparacion:FLSqlCursor,curLineaAlbaran:FLSqlCursor,idAlbaran:Number):Boolean {
	return this.ctx.oficial_datosLineaReparacion(curLineaReparacion,curLineaAlbaran,idAlbaran);
  }
  function datosAlbaran(cursor:FLSqlCursor,curAlbaran:FLSqlCursor,where:String):Boolean {
	return this.ctx.oficial_datosAlbaran(cursor,curAlbaran,where);
  }
  function totalesAlbaran(curAlbaran:FLSqlCursor):Boolean {
	return this.ctx.oficial_totalesAlbaran(curAlbaran);
  }
  function archivarReparacion() {
	return this.ctx.oficial_archivarReparacion();
  }
  function desarchivarReparacion() {
	return this.ctx.oficial_desarchivarReparacion();
  }
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends oficial {
  function head( context ) { oficial ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
  function ifaceCtx( context ) { head( context ); }
  function pub_commonCalculateField(fN:String, cursor:FLSqlCursor):String {
	return this.commonCalculateField(fN, cursor);
  }
  function pub_generarAlbaran(where:String, cursor:FLSqlCursor):Number {
	return this.generarAlbaran(where, cursor);
  }
  function pub_imprimir(codreparacion:String) {
	return this.imprimir(codreparacion);
  }
  function pub_imprimirTicket(codreparacion:String) {
	return this.imprimirTicket(codreparacion);
  }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este es el formulario maestro de reparaciones a cliente.
\end */
function interna_init()
{
    var util:FLUtil = new FLUtil;
    
  this.iface.pbnGAlbaran = this.child("pbnGenerarAlbaran");
  this.iface.tdbRecords = this.child("tableDBRecords");
  this.iface.tbnImprimir = this.child("toolButtonPrint");
  this.iface.tbnImprimirTicket = this.child("toolButtonPrintTicket");
  this.iface.pbnArchivarReparacion = this.child("pbnArchivarReparacion");

  //Filtro SAT
  this.iface.cbxTipoRep = this.child("cbxTipoRep");
  this.iface.chxInvertir = this.child("chxInvertir");
  // Filtro Fechas
  this.iface.fechaDesde = this.child("fechaDesde");
  this.iface.fechaHasta = this.child("fechaHasta");
  var mostrarDias:Number = util.sqlSelect("flsatprincipal_general", "filtrosat_reparaciones", "id = '1'");
  if (!mostrarDias || isNaN(mostrarDias)) {
      mostrarDias = 0;
  }
  mostrarDias = mostrarDias * -1;
  debug ("mostrarDias Calculados--> " + mostrarDias);
  
  var d = new Date();
  this.iface.fechaDesde.date = new Date(util.addDays(d.toString().left(10), mostrarDias) );
  this.iface.fechaHasta.date = new Date();
  
  //// Cargamos los items de cbxTipoRep
  var cargatiposrep:Array;
  var qryTiposRep:FLSqlQuery = new FLSqlQuery();
  qryTiposRep.setTablesList("sat_tiposrep");
  qryTiposRep.setSelect("tiporep");
  qryTiposRep.setFrom("sat_tiposrep");
  cargatiposrep[0] = "Todas";
  var i =1;
  if (qryTiposRep.exec())
  {
  while (qryTiposRep.next()) {
	cargatiposrep[i] = qryTiposRep.value(0);
	i++;
         }
  }
  this.iface.cbxTipoRep.insertStringList(cargatiposrep);

  this.iface.cbxEstadoRep = this.child("cbxEstadoRep");
  
  

  connect(this.iface.pbnGAlbaran, "clicked()", this, "iface.pbnGenerarAlbaran_clicked()");
  connect(this.iface.tdbRecords, "currentChanged()", this, "iface.procesarEstado");
  connect(this.iface.tbnImprimir, "clicked()", this, "iface.imprimir");
  connect(this.iface.tbnImprimirTicket, "clicked()", this, "iface.imprimirTicket");
  connect(this.iface.pbnArchivarReparacion, "clicked()", this, "iface.pbnArchivarReparacion_clicked()");

  //Filtro SAT
  connect(this.iface.cbxTipoRep, "activated(int)", this, "iface.actualizarFiltro");
  connect(this.iface.cbxEstadoRep, "activated(int)", this, "iface.actualizarFiltro");
  connect(this.iface.chxInvertir,"clicked()", this,"iface.actualizarFiltro");
  connect(this.iface.fechaDesde, "valueChanged(const QDate&)", this, "iface.actualizarFiltro");
  connect(this.iface.fechaHasta, "valueChanged(const QDate&)", this, "iface.actualizarFiltro");
  this.iface.procesarEstado();
  this.iface.actualizarFiltro();
  
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \C
Al fijar las opciones de los filtros se mostrarn las reparaciones que coincidan con los criterios seleccionados
\end */
function oficial_filtroSAT()
{
  var tipoRep:Number = this.iface.cbxTipoRep.currentItem;
  var estadoRep:Number = this.iface.cbxEstadoRep.currentItem;
  var filtro:String;
  var filtroActual:String = this.cursor().setMainFilter
  //Filtro SAT
  var cargacodtiposrep:Array;
  var qryTiposRep:FLSqlQuery = new FLSqlQuery();
  qryTiposRep.setTablesList("sat_tiposrep");
  qryTiposRep.setSelect("codtiporep");
  qryTiposRep.setFrom("sat_tiposrep");
  cargacodtiposrep[0] = "Todas";
  var i =1;
  if (qryTiposRep.exec()) {
    while (qryTiposRep.next()) {
        cargacodtiposrep[i] = qryTiposRep.value(0);
        i++;
    }
  }

 if (tipoRep > 0) filtro += " codtiporep = '"+ cargacodtiposrep[tipoRep]+"'";


  if (tipoRep > 0 && estadoRep > 0){
	  filtro += " AND ";
  }
  if (this.iface.chxInvertir.checked && estadoRep > 0)
          filtro += " NOT ";
  switch (estadoRep) {
	case 0: {
	  break;
	}
	case 1: {
	  filtro += " estado = 'PENDIENTE'";
	  break;
	}
	case 2: {
	  filtro += " estado = 'EN PROCESO'";
	  break;
	}
	case 3: {
	  filtro += " estado = 'TERMINADO'";
	  break;
	}
	case 4: {
	  filtro += " estado = 'ENTREGADO'";
	  break;
	}
	case 5: {
	  filtro += " estado = 'NO ACEPTADO'";
	  break;
	}
  }
  return filtro;
}

function oficial_actualizarFiltro()
{
    filtroSAT = this.iface.filtroSAT();
    
    var desde:String = this.iface.fechaDesde.date.toString().left(10);
    var hasta:String = this.iface.fechaHasta.date.toString().left(10);
    
    if (desde == "" || hasta == "") {
        debug("filtrosFechas_actualizarFiltro - No hay fechas que filtrar");
    }
    
    var filtroFechas:String = "fecha >= '" + desde + "' AND fecha <= '" + hasta + "'";
    
    if (filtroSAT == "") {
        filtro = filtroFechas
    } else {
        filtro = filtroFechas + " AND " + filtroSAT;
    }
    
    this.cursor().setMainFilter(filtro);
    this.iface.tdbRecords.refresh();
    this.cursor().last();
    this.iface.tdbRecords.setCurrentRow(this.cursor().at());
    //     this.iface.tdbRecords.setFocus();
    /**Este setFocus() es prctico cuando se cambia el combobox,
     *    p ero resulta molesto cuando se cambia la fecha.*/
}

function oficial_procesarEstado()
{

  if (this.cursor().valueBuffer("editable") == true) {
	this.iface.pbnGAlbaran.enabled = true;
	this.iface.pbnArchivarReparacion.enabled = true;
  } else {
	this.iface.pbnGAlbaran.enabled = false;
	this.iface.pbnArchivarReparacion.enabled = false;
  }

}

function oficial_pbnArchivarReparacion_clicked()
{
  var util:FLUtil = new FLUtil;
  var cursor:FLSqlCursor = this.cursor();

  var curRep:FLSqlCursor = new FLSqlCursor("sat_reparaciones");
  var idReparacion:Number = cursor.valueBuffer("idreparacion");

  if (cursor.valueBuffer("archivar") == true) {
	this.iface.archivarReparacion();
  } else
	this.iface.desarchivarReparacion();

  this.iface.tdbRecords.refresh();
}

function oficial_archivarReparacion()
{
  var util:FLUtil = new FLUtil;
  var curRep:FLSqlCursor = new FLSqlCursor("sat_reparaciones");
  var idReparacion:Number = this.cursor().valueBuffer("idreparacion");

	curRep.select("idreparacion = " + idReparacion);
	curRep.setModeAccess(curRep.Edit);
	curRep.first();
	curRep.setValueBuffer("archivar", false);
	if (!curRep.commitBuffer())
		return false;
}

function oficial_desarchivarReparacion()
{
  var util:FLUtil = new FLUtil;

  var curRep:FLSqlCursor = new FLSqlCursor("sat_reparaciones");
  var idReparacion:Number = this.cursor().valueBuffer("idreparacion");

	curRep.select("idreparacion = " + idReparacion);
	curRep.setModeAccess(curRep.Edit);
	curRep.first();
	curRep.setValueBuffer("archivar", true);
	if (!curRep.commitBuffer())
		return false;
}

/** \C
Al pulsar el botn de generar albarn se crear el albarn correspondiente a la reparacin seleccionada.
\end */
function oficial_pbnGenerarAlbaran_clicked()
{
  var util:FLUtil = new FLUtil;
  var cursor:FLSqlCursor = this.cursor();
  var where:String = "idreparacion = " + cursor.valueBuffer("idreparacion");
  var curRep:FLSqlCursor = new FLSqlCursor("sat_reparaciones");

  if (cursor.valueBuffer("editable") == false) {
	MessageBox.warning(util.translate("scripts", "La reparacion ya gener un albarn"), MessageBox.Ok, MessageBox.NoButton);
	this.iface.procesarEstado();
	return;
  }
  /** Si se genera el albarn se obliga a archivar la reparacin */
  if (cursor.valueBuffer("archivar") == true) {
	this.iface.archivarReparacion();
  }

  this.iface.pbnGAlbaran.setEnabled(false);

  cursor.transaction(false);
  if (this.iface.generarAlbaran(where, cursor))
	cursor.commit();
  else
	cursor.rollback();

  this.iface.tdbRecords.refresh();
  this.iface.procesarEstado();
}


/** \D
Genera el albarn asociado a uno o ms reparaciones
@param where: Sentencia where para la consulta de bsqueda de los reparaciones a agrupar
@param cursor: Cursor con los datos principales que se copiarn de la reparacin al albarn
@return Identificador del albarn generado. FALSE si hay error
\end */
function oficial_generarAlbaran(where:String, cursor:FLSqlCursor):Number
{
  var util:FLUtil = new FLUtil();

  var curAlbaran:FLSqlCursor = new FLSqlCursor("albaranescli");
  curAlbaran.setModeAccess(curAlbaran.Insert);
  curAlbaran.refreshBuffer();

  if(!this.iface.datosAlbaran(cursor,curAlbaran,where))
	return false;

  if (!curAlbaran.commitBuffer())
	return false;

  var idAlbaran:Number = curAlbaran.valueBuffer("idalbaran");
  var qryReparaciones:FLSqlQuery = new FLSqlQuery();
  qryReparaciones.setTablesList("sat_reparaciones");
  qryReparaciones.setSelect("idreparacion");
  qryReparaciones.setFrom("sat_reparaciones");
  qryReparaciones.setWhere(where);

  if (!qryReparaciones.exec())
	return false;

  var idReparacion:String;
  while (qryReparaciones.next()) {
	idReparacion = qryReparaciones.value(0);
	if (!this.iface.copiaLineas(idReparacion, idAlbaran))
	  return false;
  }

  curAlbaran.select("idalbaran = " + idAlbaran);
  if (curAlbaran.first()) {
	curAlbaran.setModeAccess(curAlbaran.Edit);
	curAlbaran.refreshBuffer();

	if(!this.iface.totalesAlbaran(curAlbaran))
	  return false;

	if (!curAlbaran.commitBuffer())
	  return false;
  }

  if(!this.iface.actualizarDatosReparacion(where, idAlbaran))
	return false;

  return idAlbaran;
}

function oficial_totalesAlbaran(curAlbaran:FLSqlCursor):Boolean
{
  with(curAlbaran) {
	setValueBuffer("neto", formalbaranescli.iface.pub_commonCalculateField("neto", curAlbaran));
	setValueBuffer("totaliva", formalbaranescli.iface.pub_commonCalculateField("totaliva", curAlbaran));
	setValueBuffer("totalirpf", formalbaranescli.iface.pub_commonCalculateField("totalirpf", curAlbaran));
	setValueBuffer("totalrecargo", formalbaranescli.iface.pub_commonCalculateField("totalrecargo", curAlbaran));
	setValueBuffer("total", formalbaranescli.iface.pub_commonCalculateField("total", curAlbaran));
	setValueBuffer("totaleuros", formalbaranescli.iface.pub_commonCalculateField("totaleuros", curAlbaran));
	setValueBuffer("codigo", formalbaranescli.iface.pub_commonCalculateField("codigo", curAlbaran));
  }
  return true;
}

function oficial_datosAlbaran(cursor:FLSqlCursor,curAlbaran:FLSqlCursor,where:String):Boolean
{
  var util:FLUtil;

  var codCliente:String = cursor.valueBuffer("codcliente");
  var codSerie:String = cursor.valueBuffer("codserie");
  var codAgente:String = cursor.valueBuffer("codagente");
  var porComision:String = cursor.valueBuffer("porcomision");
  var irpf:String = cursor.valueBuffer("irpf");
  var datosCliente:Array = flfactppal.iface.pub_ejecutarQry("clientes", "coddivisa,codpago", "codcliente = '" + codCliente + "'");

  var codEjercicio:String = flfactppal.iface.pub_ejercicioActual();
  var codAlmacen:String = flfactppal.iface.pub_valorDefectoEmpresa("codalmacen");

  var codDivisa:String = datosCliente.coddivisa;
  if (!codDivisa) codDivisa = flfactppal.iface.pub_valorDefectoEmpresa("coddivisa");

  var codPago:String = datosCliente.codpago;
  if (!codPago) codPago = flfactppal.iface.pub_valorDefectoEmpresa("codpago");

  var nomTecnico:String = "";
  var datosTec = flfactppal.iface.pub_ejecutarQry("tecnicos", "nombre,apellidos", "codtecnico = '" + cursor.valueBuffer("codtecnico") + "'");
  if (datosTec["result"] == 1)
	nomTecnico = datosTec["apellidos"] + ", " + datosTec["nombre"];

  var observaciones:String =
  util.translate("MetaData", "REPARACIN N ") + cursor.valueBuffer("codreparacion") + "     " +
  util.translate("MetaData", "Fecha: ") + util.dateAMDtoDMA(cursor.valueBuffer("fecha"));

//   if (cursor.valueBuffer("contratomant")) {
// 	observaciones += "    " + util.translate("MetaData", "MANTENIMIENTO");
//   }

  observaciones += "\n\n" +
  util.translate("MetaData", "TCNICO: ") +
  cursor.valueBuffer("codtecnico") + " - " + nomTecnico + "\n\n" +
  util.translate("MetaData", "DESCRIPCIN: ") + "\n" +
  cursor.valueBuffer("descripcion") + "\n\n" +
  util.translate("MetaData", "SOLUCIN: ") + "\n" +
  cursor.valueBuffer("solucion") + "\n\n" +
  util.translate("MetaData", "OBSERVACIONES: ") + "\n" +
  cursor.valueBuffer("observaciones");

  var fecha = new Date();
  var hora:String = fecha.toString().right(8);

  var numeroAlbaran:Number = flfacturac.iface.pub_siguienteNumero(codSerie, codEjercicio, "nalbarancli");
  if (!numeroAlbaran)
	return false;

  with(curAlbaran) {
	setValueBuffer("numero", numeroAlbaran);
	setValueBuffer("fecha", fecha);
	setValueBuffer("hora", hora);
	setValueBuffer("codejercicio", codEjercicio);
	setValueBuffer("coddivisa", codDivisa);
	setValueBuffer("codpago", codPago);
	setValueBuffer("codalmacen", codAlmacen);
	setValueBuffer("codagente", codAgente);
	setValueBuffer("porcomision", porComision);
	setValueBuffer("irpf", irpf);
	setValueBuffer("codserie", codSerie);
	setValueBuffer("tasaconv", util.sqlSelect("divisas", "tasaconv", "coddivisa = '" + codDivisa + "'"));

	setValueBuffer("codcliente", codCliente);
	setValueBuffer("cifnif", util.sqlSelect("clientes", "cifnif", "codcliente = '" + codCliente + "'"));
	setValueBuffer("nombrecliente", util.sqlSelect("clientes", "nombre", "codcliente = '" + codCliente + "'"));

	datosDir = flfactppal.iface.pub_ejecutarQry("dirclientes", "direccion,codpostal,ciudad,provincia,apartado,codpais", "codcliente = '" + codCliente + "' AND domfacturacion = 'true'");
	if (datosDir["result"] == -1) {
	  MessageBox.warning(util.translate("scripts","No se encontr una direccin de facturacin para este cliente.\nNo se puede generar el albarn"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
	  return false;
	}
	setValueBuffer("direccion", datosDir["direccion"]);
	setValueBuffer("codpostal", datosDir["codpostal"]);
	setValueBuffer("ciudad", datosDir["ciudad"]);
	setValueBuffer("provincia", datosDir["provincia"]);
	setValueBuffer("apartado", datosDir["apartado"]);
	setValueBuffer("codpais", datosDir["codpais"]);

	setValueBuffer("observaciones", observaciones);
  }

  return true;
}

function oficial_actualizarDatosReparacion(where:String, idAlbaran:String):Boolean
{
  var curReparaciones:FLSqlCursor = new FLSqlCursor("sat_reparaciones");
  curReparaciones.select(where);
  while (curReparaciones.next()) {
	curReparaciones.setModeAccess(curReparaciones.Edit);
	curReparaciones.refreshBuffer();
	curReparaciones.setValueBuffer("editable", false);
	curReparaciones.setValueBuffer("idalbaran", idAlbaran);
	if(!curReparaciones.commitBuffer())
	  return false;
  }
  return true;
}

/** \D
Copia las lneas de una reparacin como lneas de su albarn asociado
@param idReparacion: Identificador de la reparacin
@param idAlbaran: Identificador del albarn
@return VERDADERO si no hay error. FALSE en otro caso.
\end */
function oficial_copiaLineas(idReparacion:Number, idAlbaran:Number):Boolean
{
  var cantidad:Number;
  var totalEnAlbaran:Number;
  var curLineaReparacion:FLSqlCursor = new FLSqlCursor("sat_lineasreparaciones");
  curLineaReparacion.select("idreparacion = " + idReparacion);
  while (curLineaReparacion.next()) {
	curLineaReparacion.setModeAccess(curLineaReparacion.Browse);
	curLineaReparacion.refreshBuffer();
	if (!this.iface.copiaLineaReparacion(curLineaReparacion, idAlbaran))
	  return false;
  }
  return true;
}

/** \D
Copia una lneas de una reparacin en su albarn asociado
@param curServicio: Cursor posicionado en la lnea de reparacin a copiar
@param idAlbaran: Identificador del albarn
@return identificador de la lnea de albarn creada si no hay error. FALSE en otro caso.
\end */
function oficial_copiaLineaReparacion(curLineaReparacion:FLSqlCursor, idAlbaran:Number):Number
{
  var curLineaAlbaran:FLSqlCursor = new FLSqlCursor("lineasalbaranescli");
  curLineaAlbaran.setModeAccess(curLineaAlbaran.Insert);
  curLineaAlbaran.refreshBuffer();

  this.iface.datosLineaReparacion(curLineaReparacion,curLineaAlbaran,idAlbaran);

  if (!curLineaAlbaran.commitBuffer())
	return false;

  return curLineaAlbaran.valueBuffer("idlinea");
}

function oficial_datosLineaReparacion(curLineaReparacion:FLSqlCursor,curLineaAlbaran:FLSqlCursor,idAlbaran:Number):Boolean
{
  var cantidad:Number = parseFloat(curLineaReparacion.valueBuffer("cantidad"));

  with(curLineaAlbaran) {
	setValueBuffer("idalbaran", idAlbaran);
	setValueBuffer("referencia", curLineaReparacion.valueBuffer("referencia"));
	setValueBuffer("descripcion", curLineaReparacion.valueBuffer("descripcion"));
	setValueBuffer("pvpunitario", curLineaReparacion.valueBuffer("pvpunitario"));
	setValueBuffer("cantidad", cantidad);
	setValueBuffer("pvpsindto", curLineaReparacion.valueBuffer("pvpsindto"));
	setValueBuffer("pvptotal", curLineaReparacion.valueBuffer("pvptotal"));
	setValueBuffer("codimpuesto", curLineaReparacion.valueBuffer("codimpuesto"));
	setValueBuffer("iva", curLineaReparacion.valueBuffer("iva"));
	setValueBuffer("recargo", curLineaReparacion.valueBuffer("recargo"));
	setValueBuffer("dtolineal", curLineaReparacion.valueBuffer("dtolineal"));
	setValueBuffer("dtopor", curLineaReparacion.valueBuffer("dtopor"));
	setValueBuffer("irpf", curLineaReparacion.valueBuffer("irpf"));
  }
  return true;
}

function oficial_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
  var util:FLUtil = new FLUtil();
  var valor:String;

  switch (fN) {
	/** \C
	El --total-- es el --neto-- menos el --totalirpf-- ms el --totaliva-- ms el --totalrecargo-- ms el --recfinanciero--
	\end */
	case "total":
	  var neto:Number = parseFloat(cursor.valueBuffer("neto"));
	  var totalIva:Number = parseFloat(cursor.valueBuffer("totaliva"));
	  var totalRecargo:Number = parseFloat(cursor.valueBuffer("totalrecargo"));
	  valor = neto + totalIva + totalRecargo;
	  valor = parseFloat(util.roundFieldValue(valor, "sat_reparaciones", "total"));
	  break;
	  /** \C
	  El --neto-- es la suma del pvp total de las lneas de albarn
	  \end */
	  case "neto":
		valor = util.sqlSelect("lineasreparaciones", "SUM(pvptotal)", "idreparacion = " + cursor.valueBuffer("idreparacion"));
		valor = parseFloat(util.roundFieldValue(valor, "sat_reparaciones", "neto"));
		break;
		/** \C
		El --totaliva-- es la suma del iva correspondiente a las lneas de albarn
		\end */
		case "totaliva":
		  var codCli:String = cursor.valueBuffer("codcliente");
		  var regIva:String = util.sqlSelect("clientes","regimeniva","codcliente = '" + codCli + "'");
		  if(regIva == "U.E." || regIva == "Exento"){
			valor = 0;
			break;
		  }
		  valor = util.sqlSelect("sat_lineasreparaciones", "SUM((pvptotal * iva) / 100)", "idreparacion = " + cursor.valueBuffer("idreparacion"));
		  valor = parseFloat(util.roundFieldValue(valor, "sat_reparaciones", "totaliva"));
		  break;
		  /** \C
		  El --totarecargo-- es la suma del recargo correspondiente a las lneas de albarn
		  \end */
		  case "totalrecargo":
			var codCli:String = cursor.valueBuffer("codcliente");
			var regIva:String = util.sqlSelect("clientes","regimeniva","codcliente = '" + codCli + "'");
			if(regIva == "U.E." || regIva == "Exento"){
			  valor = 0;
			  break;
			}
			valor = util.sqlSelect("sat_lineasreparaciones", "SUM((pvptotal * recargo) / 100)", "idreparacion = " + cursor.valueBuffer("idreparacion"));
			valor = parseFloat(util.roundFieldValue(valor, "sat_reparaciones", "totalrecargo"));
			break;
  }
  return valor;
}


/** \C
Al pulsar el botn imprimir se lanzar el informe correspondiente a la reparacin seleccionada (en caso de que el mdulo de informes est cargado)
\end */
function oficial_imprimir(codreparacion:String)
{
  if (sys.isLoadedModule("flsatinformes")) {

	var numero:String;
	if (codreparacion)
	  numero = codreparacion;
	else {
	  if (!this.cursor().isValid())
		return;
	  numero = this.cursor().valueBuffer("codreparacion");
	}

	// 		var numCopias:Number = util.sqlSelect("facturascli f INNER JOIN clientes c ON c.codcliente = f.codcliente", "c.copiasfactura", "f.codigo = '" + codigo + "'", "facturascli,clientes");
	// 		if (!numCopias)
	// 			numCopias = 1;

	var curImprimir:FLSqlCursor = new FLSqlCursor("sat_i_reparaciones");
	curImprimir.setModeAccess(curImprimir.Insert);
	curImprimir.refreshBuffer();
	curImprimir.setValueBuffer("descripcion", "temp");
	curImprimir.setValueBuffer("d_sat__reparaciones_codreparacion", numero);
	curImprimir.setValueBuffer("h_sat__reparaciones_codreparacion", numero);
	flfactinfo.iface.pub_lanzarInforme(curImprimir, "sat_i_reparaciones");
  } else {
	flfactppal.iface.pub_msgNoDisponible("Informes");
  }
}

/** \C
Al pulsar el botn imprimir ticket se lanzar el informe correspondiente a la reparacin seleccionada (en caso de que el mdulo de informes de SAT est cargado)
\end */
function oficial_imprimirTicket(codreparacion:String)
{
  if (sys.isLoadedModule("flsatinformes")) {

    var numeroTi:String;
    if (codreparacion) {
      numeroTi = codreparacion;
      debug("hay codreparacion numeroTi");
    } else {
      debug("no hay codrep numeroTi");
      // if (!this.cursor().isValid())
      //   return;
      numeroTi = this.cursor().valueBuffer("codreparacion");
    }

    //    var numCopias:Number = util.sqlSelect("facturascli f INNER JOIN clientes c ON c.codcliente = f.codcliente", "c.copiasfactura", "f.codigo = '" + codigo + "'", "facturascli,clientes");
    //    if (!numCopias)
    //      numCopias = 1;

    var curImprimir:FLSqlCursor = new FLSqlCursor("sat_i_reparaciones");
    curImprimir.setModeAccess(curImprimir.Insert);
    curImprimir.refreshBuffer();
    curImprimir.setValueBuffer("descripcion", "temp");
    curImprimir.setValueBuffer("d_sat__reparaciones_codreparacion", numeroTi);
    curImprimir.setValueBuffer("h_sat__reparaciones_codreparacion", numeroTi);
    flfactinfo.iface.pub_lanzarInforme(curImprimir, "sat_i_reparaciones_ticket");

  } else {
    flfactppal.iface.pub_msgNoDisponible("Informes");
  }

}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

